/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.netbeansrcp.overview;

import com.netbeansrcp.taskmodel.api.Task;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import org.openide.nodes.AbstractNode;
import org.openide.util.lookup.Lookups;

/**
 *
 * @author geertjan
 */
public class TaskNode extends AbstractNode implements PropertyChangeListener {

    public TaskNode(Task task) {
        super(new TaskChildren(task), Lookups.singleton(task));
        this.setName(task.getId());
        this.setDisplayName(task.getName());
        this.setIconBaseWithExtension("com/netbeansrcp/overview/Task.png");
        task.addPropertyChangeListener(this);
    }

    @Override
    public String getHtmlDisplayName() {
        String html = "<font color='";
        Task task = this.getLookup().lookup(Task.class);
        switch (task.getPrio()) {
            case LOW:
                html += "0000FF";//blue
                break;
            case MEDIUM:
                html += "000000";//black
                break;
            case HIGH:
                html += "FF0000";//red
                break;
        }
        html += "'>" + task.getName() + "</font>";
        return html;
    }

    public void propertyChange(PropertyChangeEvent arg0) {
        if (Task.PROP_NAME.equals(arg0.getPropertyName())
                || Task.PROP_PRIO.equals(arg0.getPropertyName())) {
            setDisplayName(arg0.getNewValue() + "");
        }
    }
    
}
